from coinor.pulp import *
import coinor.dippy as dippy

prob = dippy.DipProblem("Basic Bad IP", LpMinimize)

Trucks = [ '1', '2', '3', '4', '5', '6', '7', '8', '9', '10' ]

Capacity = {
'1' : 5,
'2' : 5,
'3' : 5,
'4' : 5,
'5' : 5,
'6' : 5,
'7' : 5,
'8' : 5,
'9' : 5,
'10' : 5
}

Load = 33

truck_vars = LpVariable.dicts("UseTruck",Trucks,0,1,LpInteger)

prob += lpSum([truck_vars[i] for i in Trucks]), "TotalTrucks"
prob += lpSum([Capacity[i] * truck_vars[i] for i in Trucks]) >= Load, "CarryLoad"

prob.writeLP("BadIP.lp")

print "probvars", prob.variables()

prob.getRowBounds()
prob.getColBounds()
prob.truck_vars = truck_vars

def do_branch(prob, solution):
    """
    return (down_branch_lb, down_branch_ub, up_branch_lb, up_branch_ub), where each is a list of
    (variable, bound) 2-tuples.
    """
    import math
    tol = 1e-5

    sum_x = sum(solution[var] for name, var in prob.truck_vars.items())
    down = int(math.floor(sum_x))
    up = int(math.ceil(sum_x))

    if abs(sum_x - down) > tol and abs(up - sum_x) > tol:
        down_branch_ub = [(prob.truck_vars[str(t)], 0) for t in range(up, 11)]
        up_branch_lb = [(prob.truck_vars[str(t)], 1) for t in range(1, up+1)]
        return ([], down_branch_ub, up_branch_lb, [])
    return None
prob.branch_method = do_branch

dippy.Solve(prob)

for v in prob.variables():
    print v, v.varValue

print "obj", value(prob.objective)

